# This file was generated by Rcpp::compileAttributes
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

mvlrrl0 <- function(datasets, svs, sz, seed=0, maxIter=1000, thres=0.00001, logLvl=0) {
	
	if(length(datasets)<2){
		stop("number of datasets must be at least two")
	}
	else if(nrow(datasets[[1]])<sz){
		stop("sz cannot be larger than the number of rows in the datasets")
	}
	else if(length(datasets)!=length(svs)){
		stop("number of datasets is not equal to number of svs")
	}
	else if(!all(lapply(datasets,ncol)>=svs)){
		stop("element of each svs should be less than or equal to number of columns of its corresponding dataset")
	}
	else{
		.Call('mvcluster_clusterl0', PACKAGE = 'mvcluster', datasets, svs, sz, seed, maxIter, thres, logLvl)
	}
}

mvlrrl1 <- function(datasets, lus, lvs, lz, maxOuter=100000, thresOuter=.00001, maxInner=10000, thresInner=.00001, logLvl=0) {
	
	if(length(datasets)<2){
		stop("number of datasets must be at least two")
	}
	else if(length(datasets) != length(lvs) || length(datasets) != length(lus)){
		stop("number of datasets is not equal to number of lus/lvs")
	}
	else{
		.Call('mvcluster_clusterl1', PACKAGE = 'mvcluster', datasets, lus, lvs, lz, maxOuter, thresOuter, maxInner, thresInner, logLvl)
	}
}

mvsvdl1 <- function(datasets, lvs, lz, maxOuter=100000, thresOuter=.00001, maxInner=10000, thresInner=.00001, logLvl=0) {

	if(length(datasets)<2){
		stop("number of datasets must be at least two")
	}
	else if(length(datasets) != length(lvs)){
		stop("number of datasets is not equal to number of lvs")
	}
	else{
		.Call('mvcluster_cMvSsvd', PACKAGE = 'mvcluster', datasets, lvs, lz, maxOuter, thresOuter, maxInner, thresInner, logLvl)	
	}
}